Status: Closed Start date: 13 Mar 2018

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: New Function Estimated time: 2.01 hours

Target version: CoCoALib-0.99600 Spent time: 2.00 hours

Description

To help offer the user the chance to choose between guaranteed algorithms and fast, probably-correct ones,

create a new class VerificationLevel which can be given to indicate whether to use a guaranteed

algorithm, or the level of verification to apply after using a probably-correct one.

Possible applications are for the algorithms which use MinPoly internally (e.g. radical for 0-dim ideals),

perhaps also for primality testing (as an alternative to IsProbPrime).

Related issues:

Related to CoCoALib - Slug #1165: MinPoly over QQ: verification may be very slow Closed 12 Mar 2018

Related to CoCoALib - Design #1159: Add global enum  "verify/DontVerify" Closed 22 Feb 2018

Related to CoCoALib - Slug #866: implicit, ImplicitHypersurface: improve outp... In Progress 13 Apr 2016

History

#1 - 13 Mar 2018 18:48 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott

- % Done changed from 0 to 50

JAA has checked in a first impl (using KISS philosophy).

Anna will test it shortly.

The idea is that fns which offer guaranteed or probably-correct impls offer the user an optional final arg to say which to use (and how much checking

to do if the probably-correct impl is used).

Currently the VerificationLevel must be non-negative; 0 means do not perform any verification checks to the result.

As a special case the function guaranteed() produces a special "negative" verification level; this should be teh default value for the optional arg (and

it indicates that the guaranteed-correct algorithm should be used).

#2 - 16 Mar 2018 08:58 - Anna Maria Bigatti

- Related to Slug #1165: MinPoly over QQ: verification may be very slow added

#3 - 14 Jun 2018 16:47 - John Abbott

- Related to Design #1159: Add global enum  "verify/DontVerify" added

#4 - 02 Aug 2018 17:29 - Anna Maria Bigatti

- Status changed from In Progress to Closed

- % Done changed from 50 to 100
- Estimated time set to 2.01 h

Made and used for MinPoly.

(and documented, by John Abbott)

#5 - 02 Aug 2018 17:43 - Anna Maria Bigatti

- Related to Slug #866: implicit, ImplicitHypersurface: improve output verification added
